;ITTLE ED EADER - FILE COPIER PROGRAM
;WRITTEN 92/10/03 BY RAIG RUCE FOR = ACKING ET AGAZINE

.ORG $8000
.OBJ "@:LRR.BIN"

;====JUMP TABLE AND PARAMETERS INTERFACE ====

JMP INITACKAGE
JMP LOADIRECTORY
JMP COPYILE

.BYTE $CB,131   ;IDENTIFICATION
.BYTE 0,0,0,0

ERRNO           .BUF 1    ;(LOCATION PK+15)
SOURCEEVICE    .BUF 1
SOURCEYPE      .BUF 1    ;$00=1571, $FF=1581
STARTLUSTER    .BUF 2
LEN           .BUF 2    ;LENGTH MEDIUM AND LOW BYTES

;====GLOBAL DECLARAIONS====

KERNELISTEN = $FFB1
KERNELECOND = $FF93
KERNELNLSN  = $FFAE
KERNELCPTR  = $FFA2
KERNELIOUT  = $FFA8
KERNELPINP  = $FF47
KERNELHKOUT = $FFC9
KERNELLRCHN = $FFCC
KERNELHROUT = $FFD2

ST = $D0
CIALOCK = $DD00
CIALAGS = $DC0D
CIAATA  = $DC0C

CLUSTERLOCKOUNT .BUF 1        ;1 OR 2
FATLOCKS         .BUF 1        ;UP TO 3
ROOTIRLOCKS     .BUF 1        ;UP TO 8
ROOTIRNTRIES    .BUF 1        ;UP TO 128
TOTALECTORS      .BUF 2        ;UP TO 1440
FIRSTILELOCK    .BUF 1
FIRSTOOTIRLOCK .BUF 1
FILELUSTEROUNT  .BUF 2

BUFYLINDER     .BUF 1
BUFIDE         .BUF 1
FORMATARMS     .BUF 6

;====HARDWARE LEVEL====

SEND0 = *  ;( .=BURSTOMMANDODE ) : .=ERR
   PHA
   LDA #0
   STA ST
   LDA SOURCEEVICE
   JSR KERNELISTEN
   LDA #$6F
   JSR KERNELECOND
   LDA #"U"
   JSR KERNELIOUT
   BIT ST
   BMI SEND0RROR
   LDA #"0"
   JSR KERNELIOUT
   PLA
   JSR KERNELIOUT
   BIT ST
   BMI SEND0RROR
   CLC
   RTS

   SEND0RROR = *
   LDA #5
   STA ERRNO
   SEC
   RTS

TOGGLELOCK = *
   LDA CIALOCK
   EOR #$10
   STA CIALOCK
   RTS

SERIALAIT = *
   LDA #$08
-  BIT CIALAGS
   BEQ -
   RTS

GETURSTYTE = *
   JSR SERIALAIT
   LDX CIAATA
   JSR TOGGLELOCK
   TXA
   RTS

MOUNTISK = *  ;() : .=ERR
   LDA #%00011010
   JSR SEND0
   BCC +
   RTS
+  JSR KERNELNLSN
   BIT ST
   BMI SEND0RROR
   CLC
   JSR KERNELPINP
   BIT CIALAGS
   JSR TOGGLELOCK
   JSR GETURSTYTE
   STA ERRNO
   AND #$0F
   CMP #2
   BCS MOUNTXIT
   LDY #0
-  JSR GETURSTYTE
   STA FORMATARMS,Y
   INY
   CPY #6
   BCC -
   CLC
   ;** SET INTERLEAVE
   LDA #%00001000
   JSR SEND0
   BCC +
   RTS
+  LDA #1            ;INTERLEAVE OF 1 FOR 1581
   BIT SOURCEYPE
   BMI +
   LDA #4            ;INTERLEAVE OF 4 FOR 1571
+  JSR KERNELIOUT
   JSR KERNELNLSN
   MOUNTXIT = *
   RTS

BUFPTR = 2
SECNUM = 4

READRACK = *  ;( .=CYLINDER, .=SIDE ) : TRACKBUF, .=ERR
   PHA
   TXA
   AND #$01
   ASL
   ASL
   ASL
   ASL
   BIT SOURCEYPE
   BPL +
   EOR #$10
+  JSR SEND0
   BCC +
   RTS
+  PLA                  ;CYLINDER NUMBER
   JSR KERNELIOUT
   LDA #1               ;START SECTOR NUMBER
   JSR KERNELIOUT
   LDA #9               ;SECTOR COUNT
   JSR KERNELIOUT
   JSR KERNELNLSN
   SEI
   CLC
   JSR KERNELPINP
   BIT CIALAGS
   JSR TOGGLELOCK
   LDA #<TRACKBUF
   LDY #>TRACKBUF
   STA BUFPTR
   STY BUFPTR+1
   LDA #0
   STA SECNUM
-  BIT SOURCEYPE
   BMI +
   JSR GET1571UFTR
+  JSR READECTOR
   BCS TRACKXIT
   INC SECNUM
   LDA SECNUM
   CMP #9
   BCC -
   CLC
   TRACKXIT = *
   CLI
   RTS

GET1571UFTR = *
   LDA #<TRACKBUF
   STA BUFPTR
   LDX SECNUM
   CLC
   LDA #>TRACKBUF
   ADC BUFPTR1571,X
   STA BUFPTR+1
   RTS

BUFPTR1571 = *
   .BYTE 0,8,16,6,14,4,12,2,10

READECTOR = *  ;( BUFPTR ) : .=ERR
   JSR GETURSTYTE
   STA ERRNO
   AND #$0F
   CMP #2
   BCC +
   RTS
+  LDX #2
   LDY #0

   READYTE = *
   LDA #$08
-  BIT CIALAGS
   BEQ -
   LDA CIALOCK
   EOR #$10
   STA CIALOCK
   LDA CIAATA
   STA (BUFPTR),Y
   INY
   BNE READYTE
   INC BUFPTR+1
   DEX
   BNE READYTE
   RTS

;====LOGICAL SECTOR LEVEL====

INITACKAGE = *
   LDA #$0E
   STA $FF00
   LDA #$FF
   STA BUFYLINDER
   STA BUFIDE
   CLC
   RTS

SECTORAVE = 5

READLOCK = *  ;( .=CYLINDER,.=SIDE,.=SECTOR ) : .=BLKTR,.=ERR
   CMP BUFYLINDER
   BNE READLOCKHYSICAL
   CPX BUFIDE
   BNE READLOCKHYSICAL
   DEY
   TYA
   ASL
   CLC
   ADC #>TRACKBUF
   TAY
   LDA #<TRACKBUF
   CLC
   RTS

   READLOCKHYSICAL = *
   STA BUFYLINDER
   STX BUFIDE
   STY SECTORAVE
   JSR READRACK
   BCC READLOCKHYSICALK
   LDA ERRNO
   AND #$0F
   CMP #11    ;DISK CHANGE
   BEQ +
   SEC
   RTS
+  JSR MOUNTISK
   LDA BUFYLINDER
   LDX BUFIDE
   LDY SECTORAVE
   BCC READLOCKHYSICAL
   RTS

   READLOCKHYSICALK = *
   LDA BUFYLINDER
   LDX BUFIDE
   LDY SECTORAVE
   JMP READLOCK

DIVIDEY18 = *  ;( .=NUMBER ) : .=QUOTIENT, .=REMAINDER
   ;** COULD REPEATEDLY SUBTRACT 360 HERE
   LDX #$FF
-  INX
   SEC
   SBC #18
   BCS -
   DEY
   BPL -
   CLC
   ADC #18
   INY
   TAY
   TXA
   RTS

CONVERTOGICALLOCKUM = *  ;( .=BLOCKUM ) : .=CYL, .=SIDE, .=SEC
   JSR DIVIDEY18
   LDX #0
   CPY #9
   BCC +
   PHA
   TYA
   SBC #9
   TAY
   PLA
   LDX #1
+  INY
   RTS

DESTTR = 6
CURYLINDER = 8
CURIDE = 9
CURECTOR = 10
BLOCKOUNTDOWN = 11
SOURCETR = 12

COPYLOCKS = *  ;( .=STARTLOCK, .=BLOCKOUNT, ($6)=DEST ) : .=ERR
   STX BLOCKOUNTDOWN
   JSR CONVERTOGICALLOCKUM
   STA CURYLINDER
   STX CURIDE
   STY CURECTOR

   COPYLOCKOOP = *
   LDA CURYLINDER
   LDX CURIDE
   LDY CURECTOR
   JSR READLOCK
   BCC +
   RTS
+  STA SOURCETR
   STY SOURCETR+1
   LDX #2
   LDY #0
-  LDA (SOURCETR),Y
   STA (DESTTR),Y
   INY
   LDA (SOURCETR),Y
   STA (DESTTR),Y
   INY
   BNE -
   INC SOURCETR+1
   INC DESTTR+1
   DEX
   BNE -
   INC CURECTOR
   LDA CURECTOR
   CMP #10
   BCC +
   LDA #1
   STA CURECTOR
   INC CURIDE
   LDA CURIDE
   CMP #2
   BCC +
   LDA #0
   STA CURIDE
   INC CURYLINDER
+  DEC BLOCKOUNTDOWN
   BNE COPYLOCKOOP
   CLC
   RTS

READLUSTER = *  ;( .=CLUSTERUMBER ) : CLUSTERUF, .=ERR
   ;** CONVERT CLUSTER NUMBER TO LOGICAL BLOCK NUMBER
   SEC
   SBC #2
   BCS +
   DEY
+  LDX CLUSTERLOCKOUNT
   CPX #1
   BEQ +
   ASL
   STY 7
   ROL 7
   LDY 7
+  CLC
   ADC FIRSTILELOCK
   BCC +
   INY

   ;** READ LOGICAL BLOCKS COMPRISING CLUSTER
+  LDX #<CLUSTERUF
   STX 6
   LDX #>CLUSTERUF
   STX 7
   LDX CLUSTERLOCKOUNT
   JMP COPYLOCKS

;====- FORMAT LEVEL====

BOOTLOCK = 2

LOADIRECTORY = *  ;( ) : .=DIRBUF, .=DIRNTRIES, .=ERR
   LDA #$0E
   STA $FF00

   ;** GET PARAMETERS FROM BOOT SECTOR
   LDA #0
   LDY #0
   JSR CONVERTOGICALLOCKUM
   JSR READLOCK
   BCC +
   RTS
+  STA BOOTLOCK
   STY BOOTLOCK+1
   LDY #13              ;GET CLUSTER SIZE
   LDA (BOOTLOCK),Y
   STA CLUSTERLOCKOUNT
   CMP #3
   BCC +

   INVALIDARMS = *
   LDA #60
   STA ERRNO
   SEC
   RTS

+  LDY #16              ;CHECK  REPLICATION COUNT, MUST BE 2
   LDA (BOOTLOCK),Y
   CMP #2
   BNE INVALIDARMS
   LDY #22              ;GET  SIZE IN SECTORS
   LDA (BOOTLOCK),Y
   STA FATLOCKS
   CMP #4
   BCS INVALIDARMS
   LDY #17              ;GET DIRECTORY SIZE
   LDA (BOOTLOCK),Y
   STA ROOTIRNTRIES
   CMP #129
   BCS INVALIDARMS
   LSR
   LSR
   LSR
   LSR
   STA ROOTIRLOCKS
   LDY #19              ;GET TOTAL SECTOR COUNT
   LDA (BOOTLOCK),Y
   STA TOTALECTORS
   INY
   LDA (BOOTLOCK),Y
   STA TOTALECTORS+1
   LDY #24              ;CHECK SECTORS PER TRACK, MUST BE 9
   LDA (BOOTLOCK),Y
   CMP #9
   BNE INVALIDARMS
   LDY #26
   LDA (BOOTLOCK),Y
   CMP #2               ;CHECK NUMBER OF SIDES, MUST BE 2
   BNE INVALIDARMS
   LDY #14              ;CHECK NUMBER OF BOOT SECTORS, MUST BE 1
   LDA (BOOTLOCK),Y
   CMP #1
   BNE INVALIDARMS

   ;** GET DERIVED PARAMETERS
   LDA FATLOCKS        ;FIRST ROOT DIRECTORY SECTOR
   ASL
   CLC
   ADC #1
   STA FIRSTOOTIRLOCK
   CLC                  ;FIRST FILE SECTOR
   ADC ROOTIRLOCKS
   STA FIRSTILELOCK
   LDA TOTALECTORS     ;NUMBER OF FILE CLUSTERS
   LDY TOTALECTORS+1
   SEC
   SBC FIRSTILELOCK
   BCS +
   DEY
+  STA FILELUSTEROUNT
   STY FILELUSTEROUNT+1
   LDA CLUSTERLOCKOUNT
   CMP #2
   BNE +
   LSR FILELUSTEROUNT+1
   ROR FILELUSTEROUNT

   ;** LOAD 
+  LDA #<FATBUF
   LDY #>FATBUF
   STA 6
   STY 7
   LDA #1
   LDY #0
   LDX FATLOCKS
   JSR COPYLOCKS
   BCC +
   RTS

   ;** LOAD ACTUAL DIRECTORY
+  LDA #<DIRBUF
   LDY #>DIRBUF
   STA 6
   STY 7
   LDA FIRSTOOTIRLOCK
   LDY #0
   LDX ROOTIRLOCKS
   JSR COPYLOCKS
   BCC +
   RTS
+  LDA #<DIRBUF
   LDY #>DIRBUF
   LDX ROOTIRNTRIES
   CLC
   RTS

ENTRYDDR = 2
ENTRYORK = 4
ENTRYITS = 5
ENTRYATA0 = 6
ENTRYATA1 = 7
ENTRYATA2 = 8

GETATNTRY = *  ;( .=FATNTRYUMBER ) : .=FATNTRYALUE
   STA ENTRYITS
   ;** DIVIDE BY TWO
   STY ENTRYDDR+1
   LSR ENTRYDDR+1
   ROR

   ;** TIMES THREE
   STA ENTRYORK
   LDX ENTRYDDR+1
   ASL
   ROL ENTRYDDR+1
   CLC
   ADC ENTRYORK
   STA ENTRYDDR
   TXA
   ADC ENTRYDDR+1
   STA ENTRYDDR+1

   ;** ADD BASE, GET DATA
   CLC
   LDA ENTRYDDR
   ADC #<FATBUF
   STA ENTRYDDR
   LDA ENTRYDDR+1
   ADC #>FATBUF
   STA ENTRYDDR+1
   LDY #2
-  LDA (ENTRYDDR),Y
   STA ENTRYATA0,Y
   DEY
   BPL -
   LDA ENTRYITS
   AND #1
   BNE +

   ;** CASE 1: FIRST 12-BIT CLUSTER
   LDA ENTRYATA1
   AND #$0F
   TAY
   LDA ENTRYATA0
   RTS

   ;** CASE 2: SECOND 12-BIT CLUSTER
+  LDA ENTRYATA1
   LDX #4
-  LSR ENTRYATA2
   ROR
   DEX
   BNE -
   LDY ENTRYATA2
   RTS

;====FILE COPY LEVEL====

TRANSODE = 14
LFN = 15
CBMATATR = $60
CBMATAEN = $62
CLUSTER = $64

COPYILELUSTER = *  ;( CLUSTER, LFN, TRANSODE ) : .=ERR
   LDA CLUSTER
   LDY CLUSTER+1
   JSR READLUSTER
   BCC +
   RTS
+  LDA #<CLUSTERUF
   LDY #>CLUSTERUF
   STA CBMATATR
   STY CBMATATR+1
   LDA #0
   STA CBMATAEN
   LDA CLUSTERLOCKOUNT
   ASL
   STA CBMATAEN+1

   ;**GET NEXT CLUSTER
   LDA CLUSTER
   LDY CLUSTER+1
   JSR GETATNTRY
   STA CLUSTER
   STY CLUSTER+1
   CMP #$FF
   BNE COPYILELUSTERATA
   CPY #$0F
   BNE COPYILELUSTERATA
   LDA LEN
   STA CBMATAEN
   LDA #$01
   LDX CLUSTERLOCKOUNT
   CPX #1
   BEQ +
   LDA #$03
+  AND LEN+1
   BNE +
   LDX LEN
   BEQ COPYILELUSTERATA
+  STA CBMATAEN+1

   COPYILELUSTERATA = *
   JSR COMMIEUT
   RTS

CBMATAIMIT = $66

COMMIEUT = *  ;( CBMATATR, CBMATAEN ) : .=ERR
   LDX LFN
   BNE +
   CLC
   RTS
+  JSR KERNELHKOUT
   BCC COMMIEUTORE
   STA ERRNO
   RTS

   COMMIEUTORE = *
   LDA #255
   LDX CBMATAEN+1
   BNE +
   LDA CBMATAEN
+  STA CBMATAIMIT
   LDY #0
-  LDA (CBMATATR),Y
   BIT TRANSODE
   BPL +
   TAX
   LDA TRANSUF,X
   BEQ COMMIEEXT
+  JSR KERNELHROUT
   COMMIEEXT = *
   INY
   CPY CBMATAIMIT
   BNE -

   CLC
   LDA CBMATATR
   ADC CBMATAIMIT
   STA CBMATATR
   BCC +
   INC CBMATATR+1
+  SEC
   LDA CBMATAEN
   SBC CBMATAIMIT
   STA CBMATAEN
   BCS +
   DEC CBMATAEN+1
+  LDA CBMATAEN
   ORA CBMATAEN+1
   BNE COMMIEUTORE
   JSR KERNELLRCHN
   CLC
   RTS

COPYILE = *  ;( STARTLUSTER, LEN, .=TRANSODE, .=LFN ) : .=ERR
   LDY #$0E
   STY $FF00
   STA TRANSODE
   STX LFN
   LDA STARTLUSTER
   LDY STARTLUSTER+1
   STA CLUSTER
   STY CLUSTER+1
   JMP +
-  JSR COPYILELUSTER
   BCC +
   RTS
+  LDA CLUSTER
   CMP #$FF
   BNE -
   LDA CLUSTER+1
   CMP #$0F
   BNE -
   CLC
   RTS

TRANSUF = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$14,$09,$0D,$00,$93,$00,$00,$00 ;0
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $40,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;4
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$5B,$5C,$5D,$5E,$5F ;5
.BYTE $C0,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;6
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$DB,$DC,$DD,$DE,$DF ;7
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;8
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;9
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;A
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;B
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;C
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;D
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;E
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;F

;====BSS STORAGE====

BSS = *
TRACKBUF   = BSS
CLUSTERUF = TRACKBUF+4608  
FATBUF     = CLUSTERUF+1024
DIRBUF     = FATBUF+1536    
END        = DIRBUF+4096
